/* from Dale Schumacher's dLibs */

#include <stdio.h>
#include <stddef.h>
#include <assert.h>
#include <ansi.h>

int fputs(data, fp)
_CONST register char *data;
register FILE *fp;
{
    register int n = 0;
    
    assert((data != NULL));
    while(*data)
    {
	if(fputc(*data++, fp) == EOF)
	    return(EOF);
	++n;
    }
    return(n);
}

int puts(data)
_CONST char *data;
{
    register int n;
    
    assert((data != NULL));
    if(((n = fputs(data, stdout)) == EOF)
       || (fputc('\n', stdout) == EOF))
	return(EOF);
    return(++n);
}
