#include "lib.h"

/*  getenv(3)
 *
 *  Author: Terrence W. Holm          Aug. 1988
 */

#ifndef NULL
#define NULL ((void *)0)
#endif

extern char **environ;


char *getenv( name )
_CONST register char *name;
  {
  char **v;
  register char *n;
  _CONST register char *p;

  if ( environ == (char **) NULL  ||  name == NULL )
    return(NULL);

  for ( v = environ;  *v != NULL;  v++ )
  {
    n = (char *)name;
    p = *v;

    while ( *n == *p  &&  *n != '\0' )
	n++, p++;

    if ( *n == '\0'  &&  *p == '=' )
	return( (char *)( p + 1 ) );
    }

  return(NULL);
}
