#include "lib.h"

#ifndef CHARBITS
#	define	UNSCHAR(c)	((unsigned char)(c))
#	define  uchar		unsigned char
#else
#	define	UNSCHAR(c)	((c)&CHARBITS)
#	define  uchar		char
#endif

/*
 * memcmp - compare bytes
 */

int				/* <0, == 0, >0 */
memcmp(s1, s2, size)
_CONST _VOIDSTAR s1;
_CONST _VOIDSTAR s2;
_SIZET size;
{
	register _CONST char *scan1;
	register _CONST char *scan2;
	register _SIZET n;

	scan1 = s1;
	scan2 = s2;
	for (n = size; n > 0; n--)
		if (*scan1 == *scan2) {
			scan1++;
			scan2++;
		} else
			return(*scan1 - *scan2);

	return(0);
}
