/* from Dale Schumacher's dLibs */

#include <stdio.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

#define _NFILE NFILES

void _getbuf(FILE *);
extern	FILE	_iob[];

FILE *fdopen(h, mode)
register int h;
_CONST register char *mode;
{
    register int i;
    register unsigned int  f = 0;
    register FILE *fp = NULL;
    void _getbuf(FILE *);
    
    for(i=0; (!fp && (i < _NFILE)); ++i)
	if(!(_iob[i]._flag & (_IORW | _IOREAD | _IOWRT)))
	    fp = &_iob[i];    /* empty slot */
    if(!fp)
	return(NULL);
    while(*mode)
    {
	switch(*mode++)
	{
	  case 'r':
	    f |= _IOREAD;
	    break;
	  case 'w':
	    f |= _IOWRT;
	    break;
	  case 'a':
	    f |= _IOWRT;
	    break;
	  case '+':
	    f &= ~(_IOREAD | _IOWRT);
	    f |= _IORW;
	    break;
	  case 'b':
	    break;
	  case 't':
	    break;
	  default:
/*	    fputs("Illegal file mode.\n", stderr); */
	    return(NULL);
	}
    }
    if((i = (f & (_IORW | _IOREAD | _IOWRT))) == 0)
	return(NULL);
    if(isatty(h))
	f |= (_IODEV | _IONBF);
    else
	f |= _IOFBF;
    fp->_file = h;			/* file handle */
    fp->_flag = f;			/* file status flags */
    _getbuf(fp);
    return(fp);
}
