/* from Dale Schumacher's dLibs */

#define __SRC__	/* keep compiler happy about protos */
#include <stdio.h>
#include <stdarg.h>
#include <ansi.h>

extern int _doprnt();

int fprintf(fp, fmt, arg)
FILE *fp;
_CONST char *fmt;
int arg;
{
    return(_doprnt(fp, fmt, &arg));
}

int vfprintf(fp, fmt, args)
FILE *fp;
_CONST char *fmt;
va_list args;
{
    return(_doprnt(fp, fmt, args));
}

int printf(fmt, arg)
_CONST char *fmt;
int arg;
{
    return(_doprnt(stdout, fmt, &arg));
}

int vprintf(fmt, args)
_CONST char *fmt;
va_list args;
{
    return(_doprnt(stdout, fmt, args));
}

/* This is used by the `assert' macro.  */
void __eprintf (string, line, filename)
char *string;
long line;
char *filename; /* note if STDC then filename is already in string */
{
    (void)_doprnt(stderr, string, &line);
}
