#include "lib.h"

static long __seed = 1L;

int rand()
{
  __seed = (1103515245L * __seed + 12345) & 0x7FFFFFFF;
#ifdef __GNUC__
#ifdef __MSHORT__
  return((int) ((__seed >> 16) & 077777));
#else
  return((int) __seed);
#endif
#else
  return((int) ((__seed >> 16) & 077777));
#endif
}

void srand(val)
unsigned int val;	
{
	__seed = val;
}
