#ifndef _REGEXP_H
#define _REGEXP_H

/*
 * Definitions etc. for regexp(3) routines.
 *
 * Caveat:  this is V8 regexp(3) [actually, a reimplementation thereof],
 * not the System V one.
 */
#ifndef __GNUC__
#define void int
#endif
#define CHARBITS 0377
#define strchr index
#define NSUBEXP  10
typedef struct regexp {
	char *startp[NSUBEXP];
	char *endp[NSUBEXP];
	char regstart;		/* Internal use only. */
	char reganch;		/* Internal use only. */
	char *regmust;		/* Internal use only. */
	int regmlen;		/* Internal use only. */
	char program[1];	/* Unwarranted chumminess with compiler. */
} regexp;

#ifndef __STDC__
extern regexp *regcomp();
extern int regexec();
extern void regsub();
extern void regerror();
#else
#ifndef __NO_PROTO__
struct	regexp *regcomp(char *);
int	regexec(struct regexp *, char *, int);
void	regsub(struct regexp *, char *, char *);
#else
extern regexp *regcomp();
extern int regexec();
extern void regsub();
extern void regerror();
#endif /* __NO_PROTO__ */
#endif /* __STDC__ */

#endif /* _REGEXP_H */
