#include "lib.h"

/*
 * strncpy - copy at most n characters of string src to dst
 */
char *				/* dst */
strncpy(dst, src, n)
char *dst;
_CONST char *src;
_SIZET n;
{
	register char *dscan;
	register _CONST char *sscan;
	register _SIZET count;

	dscan = dst;
	if (!(sscan = src))
		sscan = "";
	count = n;
	while (count > 0 && (*dscan++ = *sscan++) != '\0')
		count--;
	while (count > 1)
	{
		*dscan++ = '\0';
		count--;
	}
	*dscan = '\0';	/* make sure we terminate even when n == 0 */
	return(dst);
}
