#include "lib.h"

/*
 * strspn - find length of initial segment of s consisting entirely
 * of characters from accept
 */

_SIZET
strspn(s, accept)
_CONST char *s;
_CONST char *accept;
{
	register _CONST char *sscan;
	register _CONST char *ascan;
	register _SIZET count;

	count = 0;
	for (sscan = s; *sscan != '\0'; sscan++) {
		for (ascan = accept; *ascan != '\0'; ascan++)
			if (*sscan == *ascan)
				break;
		if (*ascan == '\0')
			return(count);
		count++;
	}
	return(count);
}
